/*  General call feature for templated image classes

    Mark Jenkinson, FMRIB Image Analysis Group

    Copyright (C) 2000 University of Oxford  */

/*  CCOPYRIGHT  */

#if !defined(__fmribmain2_h)
#define __fmribmain2_h

#include <iostream>

template <class T, class S>
int fmrib_main(int argc, char* argv[]);

template <class T>
int call_fmrib_main(short datatype2, int argc, char* argv[])
{
  switch (datatype2) {
  case DT_UNSIGNED_CHAR:
    return fmrib_main<T,char>(argc, argv);
  case DT_SIGNED_SHORT:
    return fmrib_main<T,short>(argc, argv);
  case DT_SIGNED_INT:
    return fmrib_main<T,int>(argc, argv);
  case DT_FLOAT:
    return fmrib_main<T,float>(argc, argv);
  case DT_DOUBLE:
    return fmrib_main<T,double>(argc, argv);
  case DT_COMPLEX:
    cerr << "COMPLEX not supported as an independent type" << endl;
    return -1;
  default:
    return -1;
  }
}

int call_fmrib_main(short datatype1, short datatype2, int argc, char* argv[])
{
  switch (datatype1) {
  case DT_UNSIGNED_CHAR:
    return call_fmrib_main<char>(datatype2, argc, argv);
  case DT_SIGNED_SHORT:
    return call_fmrib_main<short>(datatype2, argc, argv);
  case DT_SIGNED_INT:
    return call_fmrib_main<int>(datatype2, argc, argv);
  case DT_FLOAT:
    return call_fmrib_main<float>(datatype2, argc, argv);
  case DT_DOUBLE:
    return call_fmrib_main<double>(datatype2, argc, argv);
  case DT_COMPLEX:
    cerr << "COMPLEX not supported as an independent type" << endl;
    return -1;
  default:
    return -1;
  }
}

#endif



